import pygame, sys
from pygame.locals import *
from screens.menu import Menu
from screens.gameover import GameOver

pygame.init()

class Game:
	def __init__(self):
		self.menu=Menu(self)
		self.active_screen=self.menu
		self.previous_screen=None
		self.window=pygame.display.set_mode( (992, 736) )
		self.paused_screen=None
		self.mouseimage=pygame.image.load('../images/cursor.png')
		self.clock=pygame.time.Clock()
		self.lastmousepos=(0,0)
		self.oldmusic=None
		self.window.set_colorkey(pygame.Color(20,60,80))
	def run(self):
		pygame.mouse.set_visible(False)
		while True:
			if self.previous_screen!=self.active_screen:
				self.previous_screen=self.active_screen
				music=self.active_screen.get_music()
				
				if music:
					if music!=self.oldmusic:
						pygame.mixer.music.load('../music/%s.ogg'%music)
						pygame.mixer.music.play(-1)
					else:
						#we're good dog
						pass
				else:
					pygame.mixer.music.stop()
				self.oldmusic=music
			self.active_screen.update()
			self.active_screen.draw(self.window)
			self.window.blit(self.mouseimage, self.lastmousepos)
			for event in pygame.event.get():
				#let other things also capture a mouse event, but we want to know where it is to draw it
				if event.type==MOUSEMOTION:
					self.lastmousepos=event.pos
				if event.type==QUIT:
					pygame.quit()
					sys.exit()
				elif event.type==KEYDOWN and event.key==K_ESCAPE:
					if(self.paused_screen):
						self.active_screen=self.paused_screen
						self.paused_screen=None
					elif(self.active_screen==self.menu):
						pygame.event.post(pygame.event.Event(QUIT))
					else:
						self.paused_screen=self.active_screen
						self.active_screen=self.menu
				else:
					self.active_screen.handle_event(event)
			pygame.display.update()
			self.clock.tick(30)
			
if __name__=="__main__":
	game=Game()
	game.run()