import pygame
from pygame.locals import *

class GameOver:
	def __init__(self,gameplay, game):
		self.game=game
		self.gameplay=gameplay
		self.backgroundcolor=pygame.Color(0,0,0)
		self.textcolor=pygame.Color(252,252,252)
		self.highlightedcolor=pygame.Color(88,248,152)
		self.background=pygame.image.load('../images/gameover.png')
		self.menufont=pygame.font.Font('../fonts/PressStart2P.ttf',16*2)
		self.smallfont=pygame.font.Font('../fonts/PressStart2P.ttf',16)
		self.continuehighlighted=False
		self.quithighlighted=False
		self.overtext=self.menufont.render("Game Over",False, self.textcolor,self.backgroundcolor)
		self.overrect=self.overtext.get_rect()
		self.overrect.topleft=(354+16,354)
		overmiddle=self.overrect.left+self.overrect.width/2
		self.scoretext=self.smallfont.render("Score: %i"%self.gameplay.totalpoints,False, self.textcolor,self.backgroundcolor)
		self.scorerect=self.scoretext.get_rect()
		self.scorerect.topleft=(overmiddle-self.scorerect.width/2,self.overrect.top+50)
		
		self.continuetext=self.smallfont.render("Continue",False, self.highlightedcolor,self.backgroundcolor)
		self.continuehighlight=self.smallfont.render("Continue",False, self.textcolor,self.backgroundcolor)
		self.continuerect=self.continuetext.get_rect()
		self.continuerect.topleft=(overmiddle-self.continuerect.width/2,self.scorerect.top+26)
		self.quittext=self.smallfont.render("Quit",False, self.highlightedcolor,self.backgroundcolor)
		self.quithighlight=self.smallfont.render("Quit",False, self.textcolor,self.backgroundcolor)
		self.quitrect=self.quittext.get_rect()
		self.quitrect.topleft=(overmiddle-self.quitrect.width/2,self.continuerect.top+26)
	def update(self):
		pass
	def handle_event(self, event):
		if event.type==MOUSEBUTTONUP:
			if event.button==1:
				if self.quithighlighted:
					from screens.menu import Menu
					self.game.active_screen=self.game.menu#Menu(self.game)
					self.game.paused_screen=None
				elif self.continuehighlighted:
					from screens.game import GameScreen
					newlevel=GameScreen(self.game,self.gameplay.difficulty)
					self.game.active_screen=newlevel
					self.game.paused_screen=None
		if event.type==MOUSEMOTION:
			pos=event.pos
			self.quithighlighted=False
			self.continuehighlighted=False
			if self.quitrect.collidepoint(pos):
				self.quithighlighted=True
			elif self.continuerect.collidepoint(pos):
				self.continuehighlighted=True
				
	def draw(self, window):
		window.fill(self.backgroundcolor)
		window.blit(self.background,(0,0))
		window.blit(self.overtext,self.overrect)
		window.blit(self.scoretext,self.scorerect)
		if self.continuehighlighted:
			window.blit(self.continuehighlight,self.continuerect)
		else:
			window.blit(self.continuetext,self.continuerect)
		if self.quithighlighted:
			window.blit(self.quithighlight,self.quitrect)
		else:
			window.blit(self.quittext,self.quitrect)
	def get_music(self):
		#will be gameover, but for now, nada
		return "gameover"

		
class Victory:
	def __init__(self,gameplay, game):
		self.game=game
		self.gameplay=gameplay
		self.backgroundcolor=pygame.Color( 0, 88, 248 )
		self.textcolor=pygame.Color(252,252,252)
		self.background=pygame.image.load('../images/victory.png')
		self.menufont=pygame.font.Font('../fonts/PressStart2P.ttf',16*3)
		self.smallfont=pygame.font.Font('../fonts/PressStart2P.ttf',16*1)
		self.overtext=self.menufont.render("Victory!",False, self.textcolor,self.backgroundcolor)
		self.overrect=self.overtext.get_rect()
		self.overrect.topleft=(314,80+16)
		self.continuetext=self.smallfont.render("Click to continue",False, self.textcolor, self.backgroundcolor)
		self.continuerect=self.continuetext.get_rect()
		self.continuerect.topleft=(360,252)
		
		self.scoretext=self.smallfont.render("Score: %i"%self.gameplay.totalpoints,False, self.textcolor,self.backgroundcolor)
		self.scorerect=self.scoretext.get_rect()
		self.scorerect.topleft=(self.overrect.left+self.overrect.width/2-self.scorerect.width/2,200)
		
	def update(self):
		pass
	def handle_event(self, event):
		if event.type==MOUSEBUTTONUP:
			if event.button==1:
				from screens.game import GameScreen
				self.game.active_screen=GameScreen(self.game,11)
				self.game.active_screen.totalpoints=self.gameplay.totalpoints
				self.game.paused_screen=None
				
	def draw(self, window):
		window.fill(self.backgroundcolor)
		window.blit(self.background,(0,0))
		window.blit(self.overtext,self.overrect)
		window.blit(self.scoretext,self.scorerect)
		window.blit(self.continuetext,self.continuerect)
		
	def get_music(self):
		#will be victory, but for now, nada
		return "youwin"